#include <stdio.h>
#include <stdlib.h>
#include <string.h>

#define MAX_NUM 50

void merge_sort(int *int_array, unsigned int lo, unsigned int hi){
  unsigned int mid, tmp_num, i1, i2, k;
  int p_int[MAX_NUM]; 
 
  if (lo + 1 >=  hi)
    return;

  mid = (lo + hi) >> 1;
  merge_sort(int_array, lo, mid);
  merge_sort(int_array, mid, hi);

  tmp_num = mid - lo;
  memcpy(p_int, int_array+lo, sizeof(int)*(tmp_num));

  
  k = lo;
  i1 = mid;
  i2 = 0; 
  while (i2 < tmp_num) {
    if (i1 < hi)
      if (p_int[i2] < int_array[i1]) 
        int_array[k++] = p_int[i2++];
      else
        int_array[k++] = int_array[i1++];
    else
      int_array[k++] = p_int[i2++];
  }

  return;
}

int main(int argc, char *argv[]) {
  FILE *fp;
  int c;
  unsigned int cnt, i;
  int int_array[MAX_NUM];

  if (argc < 2) {
    printf("not enough parameters\n");
    return -1;
  }

  fp  = fopen(argv[1], "r");

  if (!fp) {
    printf("invalid file\n");
    return -1;
  }  
 
  cnt = 0;
  while (fscanf(fp, "%d", &c) != EOF) {
    int_array[cnt++] = c;
    if (cnt == MAX_NUM)
      break;
  }  

  printf("%d\n", cnt);

  fclose(fp);

  merge_sort(int_array, 0, cnt);

  for (i = 0; i < cnt; ++i) {
    printf("%d\n", int_array[i]);
  }

  return 0;
}


